diff -ruN qmail-1.03-orig/qldap-cluster.h qmail-1.03-ldap-20060201-orig/qldap-cluster.h
--- qmail-1.03-orig/qldap-cluster.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qldap-cluster.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,41 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifndef __QLDAP_CLUSTER_H__
+#define __QLDAP_CLUSTER_H__
+
+int cluster_init(void);
+int cluster(char *mailhost);
+stralloc *cluster_me(void);
+
+#endif
diff -ruN qmail-1.03-orig/qldap-debug.c qmail-1.03-ldap-20060201-orig/qldap-debug.c
--- qmail-1.03-orig/qldap-debug.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qldap-debug.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,171 @@
+/*
+ * Copyright (c) 2000-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include "output.h"
+#include "qldap-debug.h"
+#include "env.h"
+#include "scan.h"
+#include "readwrite.h"
+
+#include <stdarg.h>
+
+#ifdef ENABLE_PROFILE
+#include <taia.h>
+#endif
+
+#ifdef DEBUG
+
+/* 
+ * Known LOGLEVELs: 
+ *  1 = Error, only errors are reported (not verbose)
+ *  2 = Warning, errors and warnings are reported (normaly not verbose)
+ *  4 = Info, print some information (login name and success or fail)
+ *  8 = Info^2 (more info), session forwarding and maildirmake ...
+ * 16 = Debug, more information about authentication etc.
+ * 32 = Debug^2 (more debug info), even more ...
+ * 64 = LDAP-Debug, show everything in the ldap-module
+ *128 = some more LDAP-Debug stuff (good for ldap test tool)
+ *256 = PASSWD-Debug, this shows the encrypted and clear text passwords
+ *      so use it with care 
+ *1024= profiling output (if compiled with profile support)
+ */
+
+#define LOGLEN 256
+static int addLOG;
+static unsigned long loglevel;
+substdio sslog;
+char logbuffer[LOGLEN];
+
+void
+log_init(int fd, unsigned long mask, int via_spawn)
+/* 
+ * Known LOGLEVELs: 
+ */
+{
+	char *a = env_get("LOGLEVEL");
+	
+	loglevel = 0;
+	addLOG = via_spawn;
+	if ( a && *a ) {
+		scan_ulong(a, &loglevel);
+	} else if ((a = env_get("DEBUGLEVEL")) && *a ) {
+		scan_ulong(a, &loglevel);
+	}
+	loglevel &= mask;
+
+	substdio_fdbuf(&sslog, subwrite, fd, logbuffer, sizeof(logbuffer) );
+/*	logit(4, "LOGLEVEL set to %i\n", loglevel);
+ */
+}
+
+void
+logit(unsigned long level, const char *fmt, ...)
+/* see va_output (output.c) */
+{
+	va_list ap;
+	char ch;
+
+	va_start(ap, fmt);
+	if ( ! ( loglevel & level ) ) return;
+	ch = 15;
+	if ( addLOG ) if ( substdio_put(&sslog, &ch, 1) ) return;
+	va_output(&sslog, fmt, ap);
+	va_end(ap);
+	ch = 16;
+	if ( addLOG ) if ( substdio_put(&sslog, &ch, 1) ) return;
+	if ( substdio_flush(&sslog) == -1 ) return;
+}
+
+/* use logstart, logadd and logend with care, if there is no corresponding
+   start or end starnge messages will be loged or some important messages 
+   will be lost */
+void
+logstart(unsigned long level, const char *fmt, ...)
+{
+	va_list ap;
+	char ch;
+
+	va_start(ap, fmt);
+	if ( ! ( loglevel & level ) ) return;
+	ch = 15;
+	if ( addLOG ) if ( substdio_put(&sslog, &ch, 1) ) return;
+	va_output(&sslog, fmt, ap);
+	va_end(ap);
+}
+
+void
+logadd(unsigned long level, const char *fmt, ...)
+{
+	va_list ap;
+
+	va_start(ap, fmt);
+	if ( ! ( loglevel & level ) ) return;
+	va_output(&sslog, fmt, ap);
+	va_end(ap);
+}
+
+void
+logend(unsigned long level, const char *fmt, ...)
+{
+	va_list ap;
+	char ch;
+
+	va_start(ap, fmt);
+	if ( ! ( loglevel & level ) ) return;
+	va_output(&sslog, fmt, ap);
+	va_end(ap);
+	ch = 16;
+	if ( addLOG ) if ( substdio_put(&sslog, &ch, 1) ) return;
+	if ( substdio_flush(&sslog) == -1 ) return;
+}
+
+void
+profile(const char *s)
+{
+#ifdef ENABLE_PROFILE
+	char buf[TAIA_PACK];
+	struct taia t;
+
+	taia_now(&t);
+	taia_pack(buf,&t);
+	logit(LOG_PROFILE, "PROFILE: %s @%s\n", s, buf); 
+#endif
+}
+#else /* DEBUG */
+void log_init(int fd, unsigned long mask, int via_spawn) {}
+void logit(unsigned long level, const char *fmt, ...) {}
+void logstart(unsigned long level, const char *fmt, ...) {}
+void logadd(unsigned long level, const char *fmt, ...) {}
+void logend(unsigned long level, const char *fmt, ...) {}
+void profile(const char *s) {}
+#endif
diff -ruN qmail-1.03-orig/qldap-debug.h qmail-1.03-ldap-20060201-orig/qldap-debug.h
--- qmail-1.03-orig/qldap-debug.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qldap-debug.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2000-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifndef __QLDAP_DEBUG_H__
+#define __QLDAP_DEBUG_H__
+
+extern void log_init(int fd, unsigned long mask, int via_spawn);
+extern void logit(unsigned long level, const char *fmt, ...);
+extern void logstart(unsigned long level, const char *fmt, ...);
+extern void logadd(unsigned long level, const char *fmt, ...);
+extern void logend(unsigned long level, const char *fmt, ...);
+extern void profile(const char *s);
+
+#define PROFILE(s) profile(s)
+
+#endif
diff -ruN qmail-1.03-orig/qldap-errno.c qmail-1.03-ldap-20060201-orig/qldap-errno.c
--- qmail-1.03-orig/qldap-errno.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qldap-errno.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,104 @@
+/*
+ * Copyright (c) 2000-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include "qldap-errno.h"
+#include "error.h"
+
+/* XXX TODO needs to be removed */
+int qldap_errno;
+
+const char *qldap_err_str(int enbr)
+/* returns a string that corresponds to the qldap_errno */
+{
+	switch (enbr) {
+	case OK:
+		return "successful";
+	case ERRNO:
+		return error_str(errno);
+	case FAILED:
+		return "unspecified error";
+	case PANIC:
+		return "PANIC! Fatal error";
+
+	case NOSUCH:
+		return "no such object";
+	case TOOMANY:
+		return "too many objects";
+	case TIMEOUT:
+		return "operation timed out";
+
+	case BADVAL:
+		return "bad value";
+	case ILLVAL:
+		return "illegal value";
+	case NEEDED:
+		return "needed value is missing";
+
+	case BADPASS:
+		return "authorization failed, wrong password";
+	case FORWARD:
+		return "session needs to be forwarded";
+
+	case BADCLUSTER:
+		return "misconfigured cluster";
+	case ACC_DISABLED:
+		return "account disabled";
+	case AUTH_EXEC:
+		return "unable to start subprogram";
+	case AUTH_CONF:
+		return "configuration error";
+	case AUTH_TYPE:
+		return "unsupported authentication mode";
+
+	case MAILDIR_NONEXIST:
+		return "maildir/homedir does not exist";
+	case MAILDIR_UNCONF:
+		return "no dirmaker script configured";
+	case MAILDIR_CORRUPT:
+		return "maildir seems to be corrupted";
+	case MAILDIR_CRASHED:
+		return "dirmaker script crashed";
+	case MAILDIR_FAILED:
+		return "automatic maildir/homedir creation failed";
+	case MAILDIR_HARD:
+		return "hard error in maildir/homedir creation";
+		
+	case LDAP_BIND_UNREACH:
+		return "ldap server down or unreachable";
+	case LDAP_BIND_AUTH:
+		return "wrong bind password for ldap server";
+	default:
+		return "unknown error occured";
+	}
+}
+
diff -ruN qmail-1.03-orig/qldap-errno.h qmail-1.03-ldap-20060201-orig/qldap-errno.h
--- qmail-1.03-orig/qldap-errno.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qldap-errno.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,80 @@
+/*
+ * Copyright (c) 2000-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifndef __QLDAP_ERRNO_H__
+#define __QLDAP_ERRNO_H__
+
+/* XXX TODO cleanup */
+
+extern int qldap_errno;
+
+/* generic errors */
+#define OK			0	/* all OK */
+#define ERRNO			1	/* check errno for more info */
+#define FAILED			2	/* generic failed message */
+#define PANIC			3	/* fatal error happend */
+
+#define NOSUCH			4	/* no such object */
+#define TOOMANY			5	/* too many objects */
+#define TIMEOUT			6	/* operation timed out */
+
+#define BADVAL			7	/* bad value */
+#define ILLVAL			8	/* illegal value (check failed) */
+#define NEEDED			9	/* needed value is missing */
+
+#define BADPASS			10	/* auth failed wrong password */
+#define FORWARD			11	/* session needs to be forwarded */
+
+/* auth_mod and checkpassword specific errors */
+#define BADCLUSTER		20	/* bad settings for clustering */
+#define ACC_DISABLED		21	/* account disabled */
+#define AUTH_EXEC		22	/* unable to start subprogram */
+#define AUTH_CONF		23	/* configuration error */
+#define AUTH_TYPE		24	/* unsuportet auth type */
+
+/* maildirmake specific errors */
+#define MAILDIR_NONEXIST	25	/* maildir/homedir does not exist */
+#define MAILDIR_UNCONF		26	/* no dirmaker script configured */
+#define MAILDIR_CORRUPT		27	/* maildir seems to be corrupted */
+#define MAILDIR_CRASHED		28	/* dirmaker script crashed */
+#define MAILDIR_FAILED		29	/* automatic maildir creation failed */
+#define MAILDIR_HARD		30	/* hard error in maildir creation */
+
+/* LDAP specific errnos */
+#define LDAP_BIND_UNREACH	31	/* ldap server down or unreachable */
+#define LDAP_BIND_AUTH		32	/* wrong bind password */
+
+const char *qldap_err_str(int enbr);
+/* returns a string that corresponds to the qldap_errno */
+
+#endif
diff -ruN qmail-1.03-orig/qldap-filter.c qmail-1.03-ldap-20060201-orig/qldap-filter.c
--- qmail-1.03-orig/qldap-filter.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/qldap-filter.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,210 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include "auto_break.h"
+#include "qldap.h"
+#include "qmail-ldap.h"
+#include "str.h"
+#include "stralloc.h"
+
+static stralloc escapedstr = {0};
+/*
+ * For LDAP, '(', ')', '\', '*' and '\0' have to be escaped with '\'.
+ * We ignore the '\0' case because it is not possible to have a '\0' in s.
+ */
+char *
+filter_escape(char *s)
+{
+	char	x;
+
+	/* pre reserve some space */
+	if (!stralloc_ready(&escapedstr, str_len(s))) return 0;
+	if (!stralloc_copys(&escapedstr, "")) return 0;
+	do {
+		x = *s;
+		if (x == '*' || x == '(' || x == ')' || x == '\\')
+			if (!stralloc_append(&escapedstr, "\\")) return 0;
+		if (!stralloc_append(&escapedstr, s)) return 0;
+	} while (*s++);
+	return escapedstr.s;
+}
+
+static stralloc ocfilter = {0};
+extern stralloc	objectclass;
+
+char *
+filter_objectclass(char *searchfilter)
+{
+
+	if (searchfilter == (char *)0) return 0;
+	if (objectclass.s == (char *)0 || objectclass.len == 0)
+		return searchfilter;
+	/* (&(objectclass=...)%searchfilter%) */
+	if (!stralloc_copys(&ocfilter, "(&(") ||
+	    !stralloc_cats(&ocfilter, LDAP_OBJECTCLASS) ||
+	    !stralloc_cats(&ocfilter, "=") ||
+	    !stralloc_cat(&ocfilter, &objectclass) ||
+	    !stralloc_cats(&ocfilter, ")") ||
+	    !stralloc_cats(&ocfilter, searchfilter) ||
+	    !stralloc_cats(&ocfilter, ")") ||
+	    !stralloc_0(&ocfilter))
+		return 0;
+	return ocfilter.s;
+}
+
+static stralloc filter = {0};
+
+char *
+filter_uid(char *uid)
+{
+	char	*escaped;
+	
+	if (uid == (char *)0) return 0;
+	
+	escaped = filter_escape(uid);
+	if (escaped == (char *)0) return 0;
+	
+	if (!stralloc_copys(&filter,"(") ||
+	    !stralloc_cats(&filter, LDAP_UID) ||
+	    !stralloc_cats(&filter, "=") ||
+	    !stralloc_cats(&filter, escaped) ||
+	    !stralloc_cats(&filter, ")") ||
+	    !stralloc_0(&filter))
+		return (char *)0;
+	return filter_objectclass(filter.s);
+}
+
+static int extcnt;
+
+
+char *
+filter_mail(char *mail, int *done)
+{
+	static char		*escaped;
+	static unsigned int	at, ext, len = 0;
+#ifdef DASH_EXT
+	unsigned int 		i;
+#endif
+
+	if (mail == (char *)0) {
+		len = 0;
+		return 0;
+	}
+
+	if (len == 0) {
+		escaped = filter_escape(mail);
+		if (escaped == (char *)0) return 0;
+		len = str_len(escaped);
+		at = str_rchr(escaped, '@');
+		if (escaped[at] != '@') {
+			len = 0;
+			return 0;
+		}
+		ext = at;
+		extcnt = -1;
+		*done = 0;
+	} else {
+		if (extcnt == 0) {
+			*done = 1;
+			return 0;
+		}
+#ifdef DASH_EXT
+		/*
+		 * limit ext to the first DASH_EXT_LEVELS extensions.
+		 * We will only check for (DASH_EXT_LEVELS = 4):
+		 * a-b-c-d-e-f-g-...@foobar.com
+		 * a-b-c-d-catchall@foobar.com
+		 * a-b-c-catchall@foobar.com
+		 * a-b-catchall@foobar.com
+		 * a-catchall@foobar.com
+		 * catchall@foobar.com
+		 */
+		if (ext == at)
+			for (i = 0, ext = 0, extcnt = 1;
+			    ext < at && extcnt <= DASH_EXT_LEVELS; ext++)
+				if (escaped[ext] == *auto_break) extcnt++;
+		while (ext != 0 && --ext > 0) {
+			if (escaped[ext] == *auto_break) break;
+		}
+		extcnt--;
+#else
+		/* basic qmail-ldap behavior test for username@domain.com and
+		   catchall@domain.com */
+		ext = 0;
+		extcnt = 0;
+#endif
+	}
+	
+	/* build the search string for the email address */
+	if (!stralloc_copys(&filter, "(|(" )) return 0;
+	/* mail address */
+	if (!stralloc_cats(&filter, LDAP_MAIL)) return 0;
+	if (!stralloc_cats(&filter, "=")) return 0;
+	/* username till current '-' */
+	if (!stralloc_catb(&filter, escaped, ext)) return 0;
+	if (ext != at) { /* do not append catchall in the first round */
+		/* catchall or default */
+		if (extcnt > 0) /* add '-' */
+			if (!stralloc_cats(&filter, auto_break))
+				return 0;
+		if (!stralloc_cats(&filter, LDAP_CATCH_ALL)) return 0;
+	}
+	/* @damin.com */
+	if (!stralloc_catb(&filter, escaped+at, len-at)) return 0;
+
+	/* mailalternate address */
+	if (!stralloc_cats(&filter, ")(")) return 0;
+	if (!stralloc_cats(&filter, LDAP_MAILALTERNATE)) return 0;
+	if (!stralloc_cats(&filter, "=")) return 0;
+	/* username till current '-' */
+	if (!stralloc_catb(&filter, escaped, ext)) return 0;
+	if (ext != at) { /* do not append catchall in the first round */
+		/* catchall or default */
+		if (extcnt > 0) /* add '-' */
+			if (!stralloc_cats(&filter, auto_break)) return 0;
+		if (!stralloc_cats(&filter, LDAP_CATCH_ALL)) return 0;
+	}
+	/* @domain.com */
+	if (!stralloc_catb(&filter, escaped+at, len-at)) return 0;
+	if (!stralloc_cats(&filter, "))")) return 0;
+	if (!stralloc_0(&filter)) return 0;
+
+	if (extcnt == 0) *done = 1;
+	return filter_objectclass(filter.s);
+}
+
+int
+filter_mail_ext(void)
+{
+	return extcnt;
+}
diff -ruN qmail-1.03-orig/QLDAPGROUP qmail-1.03-ldap-20060201-orig/QLDAPGROUP
--- qmail-1.03-orig/QLDAPGROUP	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/QLDAPGROUP	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,170 @@
+QMAILGROUP by Claudio Jeker <jeker@n-r-g.com>
+(c) 2004 Internet Business Solutions Ltd.
+
+
+RELEASE: $Date: 2004/12/01 14:19:49 $ ($Revision: 1.3 $)
+
+qmail-group and qmail-secretary:
+====================================
+
+While it is possible to implement simple mail distributors via multiple
+mailFrowarding entries in qmail-ldap it is not possible to do more complex or
+dynamic mail distributors. qmail-group adds this capability -- with the help of
+qmail-secretary -- to qmail-ldap.
+
+qmail-group extends the basic qmailUser object with a new LDAP objectclass
+qmailGroup. The new object adds fields to specify members, senders and
+moderators for the list together with some standard settings. To define a
+mailing group both qmailUser and qmailGroup objects are necessary.
+
+LDAP Schema:
+
+In addition to the qmailUser attributes the following additional attributes are
+defined by qmailGroup:
+
+senderconfirm:
+  If this boolean attribute is set to true than an incomming mail needs to be
+  approved by the sender. This ensures that the sender is aware that he is
+  sending to a list and makes it almost impossible to send forged mails, spam,
+  mail viruses and other junk to be distributed to list. If sender confirmation
+  is used a confirmation message is sent to the sender. This needs to reply to
+  that message if he does not do that the mail will be deleted after 1 week.
+  By default senderconfirmation is turned off.
+
+membersonly:
+  If this boolean attribute is set to true than an incomming mail needs to come
+  from a member of the list. Only the envelope sender address is used for the
+  check. Because it is easy to forge the envelope sender address sender-
+  confirmation should be enabled too.
+
+dnmember:
+filtermember:
+rfc822member:
+  Members of the group are specified by these attributes. It is possible to
+  specify a member by a LDAP distinguish name, a LDAP filter definiton or by
+  a rfc822 email address.
+ Example:
+  dnmember: uid=joe,ou=example,o=qmail-ldap,c=CH
+  filetrmember: ((objectclass=qmailUser)(employeeType=accountant))
+  rfc822member: alice@qmail-ldap.org
+
+dnsender:
+filtersender:
+rfc822sender:
+  It is possible to limit the allowed users to send to the list. If membersonly
+  is set to true and one of the sender attributes is set, mails to the list are
+  enforced to come form on of the specified senders. See also membersonly.
+
+dnmoderator:
+rfc822moderator:
+  The mail group can be moderated -- mails need to be approved by one of the
+  specified moderators. An approval message is sent t each specified moderator.
+  Again to approve a message on of the moderators needs to reply the approval
+  message. If no approval was sent in one week the mail is deleted.
+
+confirmtext:
+  This attribute can be used to specify a own confirm text used if sender-
+  confirmation is used. The usual %HEADER% magic of qmail-reply et al. can be
+  used here.
+
+moderatortext:
+  This attribute can be used to specify a own approval text used if the list
+  is moderated. The usual %HEADER% magic of qmail-reply et al. can be used
+  here too.
+
+bounceadmin:
+  Bounceadmin can be set to one or multiple rfc822 email addresses. Mail
+  delivery errors are then forwarded to these addresses instead of the sender
+  of the original mail.
+
+To enable a mail-group at least following qmailUser attributes need to be set
+too:
+
+mail: main mailaddress of the list
+mailalternateaddress: needs to be set to list-catchall@domain.tld, this is used
+  for moderation and sender confirmation but also for bounce handling.
+mailmessagestore: A valid messagestore for sender confirmation and moderation
+  is needed.
+
+
+qmail-secretary:
+
+qmail-secretary is a helper program for qmail-group and ezmlm. It implements
+both moderation and sender confirmation. qmail-group calls qmail-secretary
+internally but for ezmlm the .qmail files need to be adapted.
+
+usage (non ezmlm mode):
+qmail-secretary [ -Z ] [ -c | -C ] [[ -m addr ] ... ] [ -M file ] maildir
+
+usage (ezmlm mode):
+qmail-secretary -z ezmlmdir [ -c | -C ] [[ -m addr ] ... ] [ -M file ]
+	maildir [ ezmlm-send ... ]
+
+Options:
+-C          Disable sender confirmation (default)
+-M file     Use file as a list of moderators. One per line.
+-Z          Non ezmlm mode (default).
+-c          Enable sender confirmation
+-m addr     Add addr to the list of moderators
+-z ezmlmdir Enable ezmlm mode and use ezmlmdir as base directory for
+            configuration.
+
+qmail-secretary uses the secified Maildir to store the messages that need
+approval. Messages that need to be confirmed are stored in maildir/new and
+messages waiting for moderation approval are stored in maildir/cur.
+
+In ezmlm mode following files from ezmlmdir are read:
+mailinglist  Address of the mailing list
+inhost       Incomming Host
+inlocal      Incomming Local Address part
+outhost      Outgoing Host
+outlocal     outgoing Local Address part
+text/approve The moderation approve request text
+text/confirm The sender confirmation request text
+
+In non ezmlm mode the information are extraceted from the environment. Mainly
+from:
+$LOCAL
+$SENDER
+$HOST
+$EXT
+$APPROVEMESS
+$CONFIRMMESS
+
+LOCAL, SENDER, HOST and EXT are set by qmail-local but APPROVEMESS and
+CONFIRMMESS can be set by the caller.
+
+Mails are tagged with a cryptographic hash. Sender confirmations are received
+by $LOCAL-confirm-<HASH>@$HOST and bounces end in $LOCAL-reject-<HASH>@$HOST.
+Moderation messages are received by $LOCAL-approve-<HASH>@$HOST and bounces
+end in $LOCAL-bounce-<HASH>@$HOST.
+
+Simple setup:
+Following qmail files should be set for sender confirmation..
+
+.qmail
+|qmail-secretary -c ./Maildir/secretary
+<other deliveries>
+
+.qmail-confirm-default
+|qmail-secretary -c ./Maildir/secretary
+
+.qmail-reject-default
+|qmail-secretary -c ./Maildir/secretary
+
+It is possible to just add a .qmail-default instead of .qmail-confirm-default
+and .qmail-reject-default.
+
+Simple ezmlm setup:
+.qmail
+|qmail-secretary -c -z ezmlmdir ezmlmdir/secretary/ ezmlm-send ezmlmdir
+|ezmlm-send ezmlmdir
+|ezmlm-warn ezmlmdir || exit 0
+
+.qmail-default
+|qmail-secretary -c -z ezmlmdir ezmlmdir/secretary/ ezmlm-send ezmlmdir
+|ezmlm-manage ezmlmdir
+|ezmlm-warn ezmlmdir || exit 0
+
+The other .qmail files don't need to be modified.
+
